/*
 * This file contains code to handle the timer interrupt routines.
 */
#include "types.h"
#include "timer.h"
#include "segments.h"

unsigned long totalhits = 0;
WORD otherhits = 0;

void far TimerProc (Dummy)
WORD Dummy;
{
   WORD far *dp = &Dummy;
   PSEGMENT ps = HashFind (dp[11]);
   if (ps != 0)
   {
      BUMP(ps->hitcount);
      if (ps->Procs != 0)
	 ProcedureCount (ps->Procs, dp[10]);
   }
   else BUMP(otherhits);
   BUMP(totalhits);
   return;
}

/*
 * Binary chop search.
 * Looking for addr...
 * 	low[0] <= addr	(always true)
 * 	high[1] >= addr (if high[1] exists - I never actually reference it).
 * At end of each iteration, either:
 * 	new low > old low OR new high < old high.
 * Therefore at end of loop:
 * 	high <= low && low[0] <= addr <= high[1]
 * -> high == low && low[0] <= addr <= low[1]
 */
void ProcedureCount(p, addr)
PPD p;
WORD addr;
{
   register VALBLOCK *test;
   register VALBLOCK *low = &p->vals[0];
   VALBLOCK *high = &p->vals[p->len - 1];

   if (addr < low[0].label)	/* Not found in symbolic part of segment! */
   {
      p->miss++;
      return;
   }
   while (low < high)
   {
      test = low + (high - low + 1)/2;	/* N.B. test > low */
      if (test[0].label <= addr) low = test;
      else high = test-1;
   }
   BUMP(low[0].count);
}
